      SUBROUTINE ZF12C(F,K,NG,N,EPS,NDIG,CROOT,ITER,ITMAX,
     1IERR)
      DIMENSION CROOT(1),ITER(1)
      INTEGER K,NG,N,NDIG,ITER,ITMAX,IERR,I,IC,ICK,ICKMAX,
     1JK,KN,KNP1,KNPN,KNPNG,L,LM1,NN,NSIG,NGUESS
      REAL EPS,AX,QZ,EPS1,RP01,RTEN,RHUN,RZERO,R1,CABS,
     1AMAX1,AMIN1
      COMPLEX F,CROOT,D,DD,DEN,FPRT,FRT,H,RT,T1,T2,T3,TEM,
     1Z0,Z1,Z2,BI,XX,XL,Y0,Y1,Y2,X0,ZERO,P1,ONE,FOUR,P5,
     1CSQRT
      DATA  RZERO/0.0/,RTEN/10.0/,RHUN/100.0/,RP01/0.01/,AX/
     10.1/,ICKMAX/3/
      ZERO=(0.0,0.0)
      P1=(0.1,0.0)
      ONE=(1.0,0.0)
      FOUR=(4.0,0.0)
      P5=(0.5,0.0)
      NSIG=NDIG
      KN=K
      NGUESS=NG
      IERR=0
      IF(N.LT.1) GO TO 19
      IF(NDIG.EQ.0.AND.EPS.EQ.0.) NSIG=5
      EPS1=RTEN**(-NSIG)
      EPS1=AMIN1(EPS1,RP01)
      KNP1=KN+1
      KNPN=KN+N
      KNPNG=KN+NGUESS
      R1=EPS1
      IF(EPS1.LE.1.E-5) R1=1.E-5
      DO 1 I=1,KNPN
      ITER(I)=0
      IF(I.GT.KNPNG) CROOT(I)=ZERO
    1 CONTINUE
      L=KNP1
    2 JK=0
      ICK=0
      XL=CROOT(L)
    3 IC=0
      H=AX
      H=P1*H
      IF(CABS(XL).GT.AX) H=P1*XL
      RT=XL+H
      ASSIGN 4 TO NN
      GO TO 11
    4 Z0=FPRT
      Y0=FRT
      X0=RT
      RT=XL-H
      ASSIGN 5 TO NN
      GO TO 11
    5 Z1=FPRT
      Y1=FRT
      H=XL-RT
      D=H/(RT-X0)
      RT=XL
      ASSIGN 6 TO NN
      GO TO 11
    6 Z2=FPRT
      Y2=FRT
    7 DD=ONE+D
      T1=Z0*D*D
      T2=Z1*DD*DD
      XX=Z2*DD
      T3=Z2*D
      BI=T1-T2+XX+T3
      DEN=BI*BI-FOUR*(XX*T1-T3*(T2-XX))
      T1=CSQRT(DEN)
      QZ=RHUN*AMAX1(CABS(BI),CABS(T1))
      T2=BI+T1
      IF(CABS(T2)+QZ.EQ.QZ) T2=ZERO
      T3=BI-T1
      IF(CABS(T3)+QZ.EQ.QZ) T3=ZERO
      DEN=T2
      QZ=CABS(T3)-CABS(T2)
      IF(QZ.GT.RZERO) DEN=T3
      ASSIGN 6 TO NN
      IF(CABS(DEN).EQ.RZERO) GO TO 14
      D=-XX/DEN
      D=D+D
      H=D*H
      RT=RT+H
      IF(NSIG.EQ.0) GO TO 8
      IF(CABS(H).LE.EPS1*AMAX1(CABS(RT),AX)) GO TO 16
      IF(IC.NE.0) GO TO 3
    8 CONTINUE
      ASSIGN 9 TO NN
      GO TO 11
    9 QZ=CABS(FPRT)-CABS(Z2)*RTEN
      IF(QZ.GE.RZERO) GO TO 10
      Z0=Z1
      Z1=Z2
      Z2=FPRT
      Y0=Y1
      Y1=Y2
      Y2=FRT
      GO TO 7
   10 CONTINUE
      D=D*P5
      H=H*P5
      RT=RT-H
   11 JK=JK+1
      IF(JK.GT.ITMAX) GO TO 17
      FRT=F(RT)
      FPRT=FRT
      IF(L.EQ.1) GO TO 15
      LM1=L-1
      DO 12 I=1,LM1
      TEM=RT-CROOT(I)
      IF(CABS(TEM).LT.1.E-4) GO TO 14
   12 FPRT=FPRT/TEM
   13 CONTINUE
      IF(CABS(FPRT).LE.ABS(EPS).AND.CABS(FRT).LE.ABS(EPS))
     1 GO TO 18
      GO TO NN,(4,5,6,9)
   14 CONTINUE
      IF(IC.NE.0) GO TO 3
      TEM=RTEN*R1
      IF(CABS(RT).GT.AX) TEM=TEM*RT
      RT=RT+TEM
      D=(H+TEM)*D/H
      H=H+TEM
      GO TO 11
   15 IF(CABS(RT).LT.1.E-4) GO TO 14
      FPRT=FPRT/RT
      GO TO 13
   16 CONTINUE
      IF(IC.NE.0) GO TO 18
      IC=1
      Z0=Y1
      Z1=Y2
      Z2=F(RT)
      XL=RT
      ICK=ICK+1
      IF(ICK.LE.ICKMAX) GO TO 7
      JK=ITMAX+JK
   17 IERR=1
   18 CROOT(L)=RT
      ITER(L)=JK
      L=L+1
      IF(L.LE.KNPN) GO TO 2
      IF(IERR.EQ.0) GO TO 19
      CONTINUE
      CALL UTZF10(IERR,12)
   19 RETURN
      END
